<?php
namespace Faturamento\Entities;

use Geral\Util\DateUtil;
use Setforms2\Shared\Registry;
use Geral\Util\Ambiente;

class Corrprecserv extends Base\Corrprecserv
{
    /**
     * Salva a Tabela de correção no Banco de dados
     * @params $linhas
     *
     * @return null
     * @throws \Exception
     */
    public static function insereAtualizaTabCorrecao($linhas, $qtiniserv, $qtfinserv)
    {
        foreach ($linhas as $registro) {
            $connection = Registry::getEntityManager();
            $connection->beginTransaction();

            $nrorg = Ambiente::getNrorg();
            $data = DateUtil::getDataAtual();

            try {
                if (empty($registro['VRPEINICSERV_OLD'])) {
                    /**
                     * Linhas da tabela se nenhum valor inicial foi alterado
                     * @var \Faturamento\Entities\Corrprecserv $corrprecserv
                     */
                    $corrprecserv = Corrprecserv::getObjectByWhere('CDFILIAL = ? AND CDSERVFILI = ? AND CDCLIENTE = ? AND VRPEINICSERV = ?', array($registro['CDFILIAL'], $registro['CDSERVFILI'], $registro['CDCLIENTE'], $registro['VRPEINICSERV']));
                } else {
                    /**
                     * Linhas da tabela se nenhum valor inicial foi alterado
                     * @var \Faturamento\Entities\Corrprecserv $corrprecserv
                     */
                    $corrprecserv = Corrprecserv::getObjectByWhere('CDFILIAL = ? AND CDSERVFILI = ? AND CDCLIENTE = ? AND VRPEINICSERV = ?', array($registro['CDFILIAL'], $registro['CDSERVFILI'], $registro['CDCLIENTE'],$registro['VRPEINICSERV_OLD']));
                }


                if (empty($corrprecserv)) {
                    $corrprecserv = new Corrprecserv();

                    $corrprecserv->setCdfilial($registro['CDFILIAL']);
                    $corrprecserv->setCdservfili($registro['CDSERVFILI']);
                    $corrprecserv->setCdcliente($registro['CDCLIENTE']);
                    $corrprecserv->setVrpeinicserv($registro['VRPEINICSERV']);
                    $corrprecserv->setVrpefimserv($registro['VRPEFIMSERV']);
                    $corrprecserv->setVrpecorrserv($registro['VRPECORRSERV']);
                    $corrprecserv->setQtiniserv($qtiniserv);
                    $corrprecserv->setQtfinserv($qtfinserv);
                    $corrprecserv->setVrnovoprecoserv($registro['VRNOVOPRECOSERV']);

                    $corrprecserv->setDtinclusao($data);
                    $corrprecserv->setDtultatu($data);
                    $corrprecserv->setNrorg($nrorg);
                    $corrprecserv->setNrorginclusao(Ambiente::getNrorg());
                    $corrprecserv->setCdoperinclusao(Ambiente::getCdOperador());
                    $corrprecserv->setNrorgultatu(Ambiente::getNrorg());
                    $corrprecserv->setCdoperultatu(Ambiente::getCdOperador());
                    $corrprecserv->persist();

                    $connection->flush();
                    $connection->commit();
                } else {
                    /**
                     * Se houver uma mudança de constraints a linha deve ser excluida e inserida novamente
                     * @var \Faturamento\Entities\Corrprecserv $corrprecserv
                     */
                    $corrprecserv->delete();
                    $connection->flush();

                    $corrprecserv = new Corrprecserv();

                    $corrprecserv->setCdfilial($registro['CDFILIAL']);
                    $corrprecserv->setCdservfili($registro['CDSERVFILI']);
                    $corrprecserv->setCdcliente($registro['CDCLIENTE']);
                    $corrprecserv->setVrpeinicserv($registro['VRPEINICSERV']);
                    $corrprecserv->setVrpefimserv($registro['VRPEFIMSERV']);
                    $corrprecserv->setVrpecorrserv($registro['VRPECORRSERV']);
                    $corrprecserv->setQtiniserv($registro['QTINISERV']);
                    $corrprecserv->setQtfinserv($registro['QTFINSERV']);
                    $corrprecserv->setVrnovoprecoserv($registro['VRNOVOPRECOSERV']);

                    $corrprecserv->setDtinclusao($data);
                    $corrprecserv->setDtultatu($data);
                    $corrprecserv->setNrorg($nrorg);
                    $corrprecserv->setNrorginclusao(Ambiente::getNrorg());
                    $corrprecserv->setCdoperinclusao(Ambiente::getCdOperador());
                    $corrprecserv->setNrorgultatu(Ambiente::getNrorg());
                    $corrprecserv->setCdoperultatu(Ambiente::getCdOperador());
                    $corrprecserv->persist();

                    $connection->flush();
                    $connection->commit();
                }
            } catch (\Exception $e) {
                throw $e;
            }
        }
    }

}